divert(-1)
# AnotherLevelUp/fvwm2rc.forms.m4
#
# AnotherLevelUp is an fvwm2 configuration package.
# It is based on Red Hat's AnotherLevel.

# AnotherLevelUp started life as a copy of AnotherLevel-0.6.8-2 (default
# in the RH5.1 distribution). Original Red Hat time stamps have been
# updated as later releases of AnotherLevel have been `assimilated' (!) into
# AnotherLevelUp.

# Author John Latham, Dept. CS, University of Manchester, UK
# Email jtl@cs.man.ac.uk
# Licence: GPL
# Copyright (C) John Latham 1998, 1999, 2000, 2001, 2002, 2003, 2007 and Red Hat Software, Inc

#------------------------------------------------------------------------------

# AnotherLevel - A FVWM2 Configuration
# Copyright (C) 1996, 1997 Red Hat Software, Inc
#
#	$Id: fvwm2rc.forms.m4,v 1.3 1999/03/22 23:25:18 pbrown Exp $	
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This work is derived from:
#       TheNextLevel
#       Copyright 1996 By Greg J. Badros <gjb@cs.duke.edu>
# distributed under GNU General Public License.
#

# This file is m4-included by .fvwm2rc.modules, which was included
# by .fvwm2rc.m4
#

# Not all of the forms listed below are used.
# More work needs to be done, but the FvwmForm module is a moving
# (and greatly improving) target, so this work will have to wait

#FormText(<Form>,[{left,center,expand}],`<text>')
define(`FormText',`ifelse($2,,,`*$1Line $2')
*$1Text "$3"')

#FormInput(<Form>,{left,center,expand},`<prompt>',<variable>,<length>,`<initial-value>')
define(`FormInput',`ifelse($2,,,`*$1Line $2')
*$1Text "$3"
*$1Input $4 $5 "$6"')

# Note: These macros gets undefine-d at end of this file.
divert

############################################################################
#
# FvwmForm LogoutVerify -- Modified from FvwmForm man page.
#

*LogoutVerifyGrabServer
*LogoutVerifyWarpPointer

*LogoutVerifyFont		FORM_FONT
*LogoutVerifyButtonFont		FORM_BUTTONFONT
*LogoutVerifyInputFont		FORM_INPUTFONT
*LogoutVerifyFore		FORM_FORE
*LogoutVerifyBack		FORM_BACK
*LogoutVerifyItemFore		FORM_ITEMFORE
*LogoutVerifyItemBack		FORM_ITEMBACK

# begin items
*LogoutVerifyLine          center
*LogoutVerifyText         "Do you really want to logout?"
*LogoutVerifyLine          expand
*LogoutVerifyButton        quit      "Yes" Y
*LogoutVerifyCommand       Quit
*LogoutVerifyButton        quit      "Cancel" 
*LogoutVerifyCommand       Nop
*LogoutVerifyButton        quit      "Restart Fvwm2" R
*LogoutVerifyCommand       Function ReallyRestart
# Fvwm window style
Style "LogoutVerify" 		StickyOnTop

###############################################################################
#
# FvwmForm About -- Fvwm's About Box
#

*AboutWarpPointer

*AboutFont		FORM_FONT
*AboutButtonFont	FORM_BUTTONFONT
*AboutInputFont		FORM_INPUTFONT
*AboutFore		FORM_FORE
*AboutBack		FORM_BACK
*AboutItemFore		FORM_ITEMFORE
*AboutItemBack		FORM_ITEMBACK

*AboutLine		center
*AboutText		"AnotherLevelUp - a FVWM2 configuration"
*AboutLine		center
*AboutText		"based on AnotherLevel, Copyright (C) 1997, Red Hat Software, Inc."

*AboutLine		center
*AboutText              "AnotherLevelUp enhancements by John Latham, (C) 1998 - 2007"
*AboutLine		center
*AboutText		"School of Computer Science, The University of Manchester, U.K."
*AboutLine		center
*AboutText		"---------------------------"

FormText(About,left,`Serverhost=SERVERHOST, Clienthost=CLIENTHOST')
FormText(About,left,`Hostname=HOSTNAME, Ostype=OSTYPE, User=USER')
FormText(About,left,`Version=VERSION, Revision=6')
FormText(About,left,`Vendor=VENDOR, Release=RELEASE')
FormText(About,left,`Width=WIDTH, Height=HEIGHT')
FormText(About,left,`X_Resolution=X_RESOLUTION, Y_Resolution=Y_RESOLUTION')
FormText(About,left,`Planes=PLANES, Class=CLASS, Color=COLOR')
FormText(About,left,`Fvwm_Version=FVWM_VERSION, Options=OPTIONS')
ifdef(`RH5', `
FormText(About,left,`Fvwmdir=FVWMDIR')
', `
FormText(About,left,`Fvwmdir=FVWM_MODULEDIR')
')

FormText(About,left,`AnotherLevelUp=ANOTHERLEVEL')


*AboutLine		center
*AboutButton		quit	"Dismiss"
*AboutButton		quit	"ALU_WEB_SITE"
*AboutCommand		Exec WEBBROWSER_BROWSE_URL(ALU_WEB_SITE)
*AboutButton		quit	"Acknowledgement"
*AboutCommand		FvwmForm Acknowledge

Style "About" StickyOnTop

###############################################################################
#
# FvwmForm Acknowledge -- 
#

*AcknowledgeWarpPointer

*AcknowledgeFont	FORM_FONT
*AcknowledgeButtonFont	FORM_BUTTONFONT
*AcknowledgeInputFont	FORM_INPUTFONT
*AcknowledgeFore	FORM_FORE
*AcknowledgeBack	FORM_BACK
*AcknowledgeItemFore	FORM_ITEMFORE
*AcknowledgeItemBack	FORM_ITEMBACK

FormText(Acknowledge,left,`Special thanks to Ryan Bliss of www.digitalblasphemy.com')
FormText(Acknowledge,left,`for permission to use the seven images in the shared themes')
FormText(Acknowledge,left,`    DB Adrift')
FormText(Acknowledge,left,`    DB Borealis')
FormText(Acknowledge,left,`    DB Fraxsplosion')
FormText(Acknowledge,left,`    DB Gazebo')
FormText(Acknowledge,left,`    DB Inner Earth')
FormText(Acknowledge,left,`    DB Red Sky')
FormText(Acknowledge,left,`    DB Valley')
FormText(Acknowledge,left,`There are many more images available in the free gallery at')
FormText(Acknowledge,left,`www.digitalblasphemy.com')
*AcknowledgeLine	center
*AcknowledgeButton	quit	"Dismiss"
*AcknowledgeButton	quit	"http://www.digitalblasphemy.com"
*AcknowledgeCommand	Exec WEBBROWSER_BROWSE_URL(http://www.digitalblasphemy.com)

Style "Acknowledge" StickyOnTop

###########################################################################
#
# FvwmForm Xrsh -- Start a program on a remote machine
#

*XrshFont		FORM_FONT
*XrshButtonFont		FORM_BUTTONFONT
*XrshInputFont		FORM_INPUTFONT
*XrshFore		FORM_FORE
*XrshBack		FORM_BACK
*XrshItemFore		FORM_ITEMFORE
*XrshItemBack		FORM_ITEMBACK

# begin items
*XrshLine         center
*XrshText         "Xrsh"
*XrshFont         BASIC_FONT*FONT_STYLE*n*FONT_SIZE*
*XrshLine         expand
*XrshSelection    Host single
foreach(`HOST',USER_HOST_LIST,`*XrshChoice HOST HOST off "capitalize(HOST)"
')
*XrshLine         expand
define(`XRSH_HOSTMAP',`foreach(HOST,USER_HOST_LIST,`$(HOST?XRSH_OR_XON HOST)')')
foreach(APPLICATION,`(emacs,xemacs,xload,WEBBROWSER_PROGRAM,XTERM)',`
*XrshButton	quit "APPLICATION" ShortcutKey(APPLICATION,XrshHosts)
*XrshCommand    Exec XRSH_HOSTMAP APPLICATION
')
*XrshButton       quit "Cancel" ^[
*XrshCommand      Nop

###########################################################################
#
# FvwmForm Rlogin -- Rlogin to an arbitrary remote machine
#

*RloginWarpPointer

*RloginFont		FORM_FONT
*RloginButtonFont		FORM_BUTTONFONT
*RloginInputFont		FORM_INPUTFONT
*RloginFore		FORM_FORE
*RloginBack		FORM_BACK
*RloginItemFore		FORM_ITEMFORE
*RloginItemBack		FORM_ITEMBACK

# begin items
*RloginLine         center
*RloginText         "Login to Remote Host"
FormInput(Rlogin,center,`Host:',HostName,20,)
*RloginLine         center
*RloginSelection    UserSel   single
*RloginChoice       Default   Default   on   "USER"
*RloginChoice       Custom    Custom    off  "Username:"
*RloginInput        UserName  10   ""
*RloginLine         expand
*RloginButton       quit "Login" ^M
*RloginCommand Exec xterm  -T xterm@$(HostName) -e rlogin $(HostName) $(Custom?-l $(UserName))
*RloginButton       restart   "Clear"
*RloginCommand Beep
*RloginButton       quit "Cancel"
*RloginCommand Nop

###########################################################################
#
# FvwmForm TalkForm FvwmTalk module which dissappears after use
# (Was: MyTalk & MyFvwmTalk from Dave Goldberg)
#

*TalkFormWarpPointer

*TalkFormFont		FORM_FONT
*TalkFormButtonFont	FORM_BUTTONFONT
*TalkFormInputFont	FORM_INPUTFONT
*TalkFormFore		FORM_FORE
*TalkFormBack		FORM_BACK
*TalkFormItemFore	FORM_ITEMFORE
*TalkFormItemBack	FORM_ITEMBACK

*TalkFormLine center
*TalkFormText "Fvwm Function"
*TalkFormInput Func 40 ""
*TalkFormLine expand
*TalkFormButton quit "Run" ^M
*TalkFormCommand $(Func)
*TalkFormButton restart "Clear" ^R
*TalkFormButton quit "Cancel" ^C
*TalkFormCommand Nop

###########################################################################
#
# Capture Window (from man page)
#

Style Capture StickyOnTop

*CapturePosition	0 0
*CaptureFont		FORM_FONT
*CaptureButtonFont	FORM_BUTTONFONT
*CaptureInputFont	FORM_INPUTFONT
*CaptureFore		FORM_FORE
*CaptureBack		FORM_BACK
*CaptureItemFore	FORM_ITEMFORE
*CaptureItemBack	FORM_ITEMBACK

*CaptureLine        center
*CaptureText        "Capture Window"
*CaptureLine        left
*CaptureText        "File:    "
*CaptureInput       file      50   "HOME/captured-window"
*CaptureLine        left
*CaptureText        "Printer: "
# ???? choice of printer name will be made persistent sometime soon.
*CaptureInput       printer        50   "lp"
*CaptureLine        left
*CaptureText        "Choose xwd options, press Capture, then click in window."
*CaptureLine        left
*CaptureText        "xwd options:"
*CaptureLine        expand
*CaptureSelection   Options   multiple
*CaptureChoice      Brd  -nobdrs   off  "No border"
*CaptureChoice      Frm  -frame    on   "With frame"
*CaptureChoice      XYZ  -xy   off  "XY Format"
*CaptureLine        expand

*CaptureButton      continue  "Capture" ^M
# Must not use a function for CaptureCommand,
# because of mouse grab during functions.
# This configuration works with FVWM 2.2, 2.4 and 2.5
*CaptureCommand     Function BusyCursorReadOff
*CaptureCommand     Current [Capture] Iconify
*CaptureCommand     PipeRead "xwd -out \"$(file)\" $(Options); >/dev/null"
*CaptureCommand     Prev [Capture] Iconify
*CaptureCommand     Function BusyCursorReadDefault

*CaptureButton      continue  "Preview"
*CaptureCommand     Exec exec xwud -in $(file) &
*CaptureButton      continue  "Print"
*CaptureCommand     Exec convert -rotate "90>" $(file) ps:- | lpr -P $(printer) ; RXVT -e sh -c "lpq -P$(printer); echo Press return to continue; read X"
*CaptureButton      quit      "Quit"


###########################################################################
#
# FvwmForm AudioEvents
#
# This is incomplete in that it'd be cool if you could save your settings
# and reload them.... but I don't even use FvwmAudio, alas I can't
# concentrate on this for now

*AudioEventsFont	FORM_FONT
*AudioEventsButtonFont	FORM_BUTTONFONT
*AudioEventsInputFont	FORM_INPUTFONT
*AudioEventsFore	FORM_FORE
*AudioEventsBack	FORM_BACK
*AudioEventsItemFore	FORM_ITEMFORE
*AudioEventsItemBack	FORM_ITEMBACK

FormInput(AudioEvents,left,`startup',startup,50,`bud.au')
FormInput(AudioEvents,,`shutdown',shutdown,50,`')
FormInput(AudioEvents,left,`unknown',unknown,50,`doh.au')
FormInput(AudioEvents,left,`add_window',add_window,50,`gong.wav')
FormInput(AudioEvents,left,`raise_window',raise_window,50,`chimes.wav')
FormInput(AudioEvents,left,`lower_window',lower_window,50,`beep1.wav')
FormInput(AudioEvents,left,`focus_change_window',focus_change_window,50,`beep1.wav')
FormInput(AudioEvents,left,`destroy_window',destroy_window,50,`splat.wav')
FormInput(AudioEvents,left,`iconify',iconify,50,`splat.wav')
FormInput(AudioEvents,left,`deiconify',deiconify,50,`ploop.au')
FormInput(AudioEvents,left,`toggle_paging',toggle_paging,50,`fwop.au')
FormInput(AudioEvents,left,`new_page',new_page,50,`beam_trek.au')
FormInput(AudioEvents,left,`new_desk',new_desk,50,`beam_trek.au')
FormInput(AudioEvents,left,`configure_window',configure_window,50,`huh.au')
FormInput(AudioEvents,left,`window_name',window_name,50,`beep.au')
FormInput(AudioEvents,left,`icon_name',icon_name,50,`beep.au')
FormInput(AudioEvents,left,`res_class',res_class,50,`beep.au')
FormInput(AudioEvents,left,`res_name',res_name,50,`beep.au')
FormInput(AudioEvents,left,`end_windowlist',end_windowlist,50,`beep.au')
*AudioEventsLine expand
*AudioEventsButton quit "Quit" 
*AudioEventsButton nop "Apply" A
#FIX: Add the rest in here, if this works
*AudioEventsCommand *FvwmAudio raise_window $(raise_window)
*AudioEventsCommand *FvwmAudio lower_window $(lower_window)

###########################################################################

undefine(`FormText')

###########################################################################
# This form is for querying user if want to restart after changes to
# settings has been made

*RestartAfterChangesWarpPointer

*RestartAfterChangesFont	FORM_FONT
*RestartAfterChangesButtonFont	FORM_BUTTONFONT
*RestartAfterChangesInputFont	FORM_INPUTFONT
*RestartAfterChangesFore	FORM_FORE
*RestartAfterChangesBack	FORM_BACK
*RestartAfterChangesItemFore	FORM_ITEMFORE
*RestartAfterChangesItemBack	FORM_ITEMBACK

*RestartAfterChangesLine left
*RestartAfterChangesText "The changes you have made will not apply until you"
*RestartAfterChangesLine left
*RestartAfterChangesText "next restart Fvwm2."
*RestartAfterChangesLine expand
*RestartAfterChangesLine left
*RestartAfterChangesText "If you want to make more changes first,"
*RestartAfterChangesLine left
*RestartAfterChangesText "you may ignore this form until you are ready,"
*RestartAfterChangesLine left
*RestartAfterChangesText "or make it go away for now."
*RestartAfterChangesLine expand
*RestartAfterChangesLine expand
*RestartAfterChangesLine expand
*RestartAfterChangesButton quit "I want to Restart now" ^M
*RestartAfterChangesCommand Function ReallyRestartWithoutRandomPreferences
*RestartAfterChangesButton quit "Go away - I will Restart later"  ^C
*RestartAfterChangesCommand Nop

Style RestartAfterChanges StickyOnTop

AddToFunc RestartAfterChanges
+ "I" PipeRead ANOTHERLEVEL/bin/kill-all-fvwm-form RestartAfterChanges
+ "I" FvwmForm RestartAfterChanges
