divert(-1)
# AnotherLevelUp/fvwm2rc.init.m4
#
# AnotherLevelUp is an fvwm2 configuration package.
# It is based on Red Hat's AnotherLevel.

# AnotherLevelUp started life as a copy of AnotherLevel-0.6.8-2 (default
# in the RH5.1 distribution). Original Red Hat time stamps have been
# updated as later releases of AnotherLevel have been `assimilated' (!) into
# AnotherLevelUp.

# Author John Latham, Dept. CS, University of Manchester, UK
# Email jtl@cs.man.ac.uk
# Licence: GPL
# Copyright (C) John Latham 1999, 2000, 2001, 2002, 2003 and Red Hat Software, Inc

#------------------------------------------------------------------------------

# AnotherLevel - A FVWM2 Configuration
# Copyright (C) 1996, 1997 Red Hat Software, Inc
#
#	$Id: fvwm2rc.init.m4,v 1.2 1998/05/01 23:57:15 gafton Exp $	
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This work is derived from:
#       TheNextLevel
#       Copyright 1996 By Greg J. Badros <gjb@cs.duke.edu>
# distributed under GNU General Public License.
#
divert

###########################################################################
#
# Stuff to do at start-up
#

# SetupFunction gets run at Init and Restart

AddToFunc "SetupFunction"
+ "I" SetBackground
+ "I" Module FvwmCommandS
ifdef(`WANT_SOUND_EVENTS',`+ "I" Module FvwmAudio
')dnl

changecom(%%%)
ifdef(`START_XSNOW', `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xsnow; xsnow ifdef(`XSNOW_OPTIONS1', XSNOW_OPTIONS1) ifdef(`XSNOW_OPTIONS2', XSNOW_OPTIONS2) ifdef(`XSNOW_OPTIONS3', XSNOW_OPTIONS3) ifdef(`XSNOW_OPTIONS4', XSNOW_OPTIONS4)
', `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xsnow'
)dnl
ifdef(`START_XEYES', `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xeyes; xeyes ifdef(`XEYES_OPTIONS1', XEYES_OPTIONS1) ifdef(`XEYES_OPTIONS2', XEYES_OPTIONS2) ifdef(`XEYES_OPTIONS3', XEYES_OPTIONS3) ifdef(`XEYES_OPTIONS4', XEYES_OPTIONS4)
', `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xeyes
')dnl
ifdef(`START_XEARTH', `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xearth; xearth ifdef(`XEARTH_OPTIONS1', XEARTH_OPTIONS1) ifdef(`XEARTH_OPTIONS2', XEARTH_OPTIONS2) ifdef(`XEARTH_OPTIONS3', XEARTH_OPTIONS3) ifdef(`XEARTH_OPTIONS4', XEARTH_OPTIONS4)
', `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xearth
')dnl
changecom(#)

+ "I" PipeRead "ANOTHERLEVEL/bin/toggle-functions -menu"
+ "I" PipeRead "ANOTHERLEVEL/bin/toggle-functions -restart"

esyscmd(ANOTHERLEVEL/bin/toggle-functions -functions)

# EndSetupFunction gets run at Init and Restart, but after StartupFunction
# is executed for the Init case

AddToFunc "EndSetupFunction"
#+ "I" Next [!iconic CurrentScreen XTERM] Focus
#+ "I" CursorMove -100 100
#??? This does not work
ifdef(`HASPOINTER_STYLE_AVAILABLE', `
+ "I" All (HasPointer) Focus
')

# StartupFunction only gets run at Init, not at Restart.
# It is run after SetupFunction, but before EndSetupFunction
AddToFunc "StartupFunction"

ifelse(SCREEN_SIZE,`Huge',`
changecom(%%%)
ifdef(`START_XTERM1', `+ "I" Exec INITXTERM1
')dnl
ifdef(`START_XTERM2', `+ "I" Exec INITXTERM2
')dnl
ifdef(`START_XTERM3', `+ "I" Exec INITXTERM3
')dnl
ifdef(`START_XEDITOR', `ifdef(`INITXEDITOR', `+ "I" Exec INITXEDITOR
')dnl')
ifdef(`START_XCAL', `+ "I" Exec INITXCAL
')dnl
changecom(#)
', `
#+ "I" Exec XTERM +ut -geometry +PctOfScreenInPixelsX(15)+PctOfScreenInPixelsY(15)
+ "I" Exec XTERM +ut -geometry +0+PctOfScreenInPixelsY(15)
')

# control-panel has disappeared by RH7.3, so it is time to remove this.
#syscmd(`test "$USER" = "root"')dnl
#ifelse(sysval,0,+ "I" Exec control-panel,)

ifdef(`START_WEBBROWSER', `
ifdef(`WEBBROWSER_DEFAULT', `
+ "I" Exec WEBBROWSER_DEFAULT
')')

ifelse(SCREEN_SIZE,`Huge',`
#+ "I" Exec emacs -geometry 104x60-1+1
#+ "I" Exec XTERM
',SCREEN_SIZE,`Large',`
#+ "I" Exec emacs -geometry 84x48-1+1
#+ "I" Exec XTERM -geometry 80x22+1-BOTTOM_EDGE
',SCREEN_SIZE,`Moderate',`
#+ "I" Exec emacs -geometry 80x40-1+1
#+ "I" Exec XTERM -geometry 80x30+1-BOTTOM_EDGE
',SCREEN_SIZE,`Small',`
#+ "I" Exec emacs -geometry 80x38-1+1
#+ "I" Exec XTERM -geometry 80x15+1-BOTTOM_EDGE
')
IfProgramExists(`unclutter',`
+ "I" Exec unclutter')

+ "I" PipeRead "ANOTHERLEVEL/bin/toggle-functions -start"

+ "I" Function ExecuteAdvancedInitialScript

####################################################################
# Advanced initial script

AddToFunc EditAdvancedInitialScript
+ "I" Exec ANOTHERLEVEL/bin/advanced-initial-script "XEDITOR"

AddToFunc ExecuteAdvancedInitialScript
+ "I" Exec ANOTHERLEVEL/bin/advanced-initial-script -execute


####################################################################
# Restarting functions
#

# Function to shut down things which may be restarted by SetupFunction

AddToFunc SetDownFunction
+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xsnow
+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xeyes
+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xearth
+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xlock

# Function to restart

AddToFunc ReallyRestart
+ "I" FvwmForm PleaseWait
+ "I" Wait PleaseWait
ifdef(`ENABLE_CACHE', + "I" Exec /bin/rm -f CACHE_FILE)
+ "I" PipeRead "ANOTHERLEVEL/bin/toggle-functions -restop"
+ "I" Function SetDownFunction
+ "I" Restart SIMPLE_RESTART_ARGUMENT

# Function to restart without changing random preferences

AddToFunc ReallyRestartWithoutRandomPreferences
+ "I" FvwmForm PleaseWait
+ "I" Wait PleaseWait
ifdef(`ENABLE_CACHE', + "I" Exec /bin/rm -f CACHE_FILE)
+ "I" PipeRead "ANOTHERLEVEL/bin/preferences-random -set_no_change"
+ "I" PipeRead "ANOTHERLEVEL/bin/toggle-functions -restop"
+ "I" Function SetDownFunction
+ "I" Restart SIMPLE_RESTART_ARGUMENT

# Function to restart with a particular window manager

AddToFunc ReallyRestartWm
+ "I" FvwmForm PleaseWait
+ "I" Wait PleaseWait
ifdef(`ENABLE_CACHE', + "I" Exec /bin/rm -f CACHE_FILE)
+ "I" PipeRead "ANOTHERLEVEL/bin/toggle-functions -restop"
+ "I" Function SetDownFunction
+ "I" Restart $0

changecom(%%%)
AddToFunc ReprocessComponents
+ "I" FvwmForm PleaseWait
+ "I" Wait PleaseWait
+ "I" PipeRead "ANOTHERLEVEL/bin/reprocess-components \"$0\" \"ANOTHERLEVEL\" \"WIDTH\" \"USER\" \"HOME\" \"USER_PREFS_DIR\" \"USER_ALL_THEMES_PREFS_DIR\" \"NICELEVEL\" \"GENERAL_FONT_FAMILY\" \"BASIC_FONT\" \"SMALL_FONT\" \"WINFORE_COLOR\" \"WINBACK_COLOR\" \"HILIGHTFORE_COLOR\" \"HILIGHTBACK_COLOR\" \"MAIL_SPOOL_DIR\" \"XTERM\" \"WEBBROWSER_DEFAULT\" \"FVWM_VERSION\" "
+ "I" Exec ANOTHERLEVEL/bin/kill-all-fvwm-form PleaseWait 
changecom(#)


*PleaseWaitFont		FORM_FONT
*PleaseWaitButtonFont	FORM_BUTTONFONT
*PleaseWaitInputFont	FORM_INPUTFONT
*PleaseWaitFore		FORM_FORE
*PleaseWaitBack		FORM_BACK
*PleaseWaitItemFore	FORM_ITEMFORE
*PleaseWaitItemBack	FORM_ITEMBACK

*PleaseWaitLine 	center
*PleaseWaitText 	"Please Wait..."
*PleaseWaitLine 	expand
*PleaseWaitText 	"(This can take a few minutes)"
*PleaseWaitLine 	expand
