divert(-1)
# AnotherLevelUp/fvwm2rc.modules.m4
#
# AnotherLevelUp is an fvwm2 configuration package.
# It is based on Red Hat's AnotherLevel.

# AnotherLevelUp started life as a copy of AnotherLevel-0.6.8-2 (default
# in the RH5.1 distribution). Original Red Hat time stamps have been
# updated as later releases of AnotherLevel have been `assimilated' (!) into
# AnotherLevelUp.

# Author John Latham, Dept. CS, University of Manchester, UK
# Email jtl@cs.man.ac.uk
# Licence: GPL
# Copyright (C) John Latham 1999, 2000, 2001, 2002, 2007 and Red Hat Software, Inc

#------------------------------------------------------------------------------

# AnotherLevel - A FVWM2 Configuration
# Copyright (C) 1996, 1997 Red Hat Software, Inc
#
#	$Id: fvwm2rc.modules.m4,v 1.3 1999/03/10 19:51:45 notting Exp $	
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This work is derived from:
#       TheNextLevel
#       Copyright 1996 By Greg J. Badros <gjb@cs.duke.edu>
# distributed under GNU General Public License.
#
divert

###########################################################################
###### PowerButtons (a button bar at the bottom of the screen)
*PowerButtonsRows 1
*PowerButtonsGeometry -0-BOTTOM_EDGE
*PowerButtonsFore WINFORE_COLOR
*PowerButtonsBack WINBACK_COLOR
*PowerButtons(Icon mini-display.xpm, Action 'Exec "XTERM" XTERM')
*PowerButtons(Icon mini-book1.xpm, Action 'Exec "xman" xman')
Style "PowerButtons" StickyOnTop, NoDecoration

###########################################################################
##### NoClutter
*FvwmNoClutter 3600 Iconify 1
*FvwmNoClutter 86400 Delete
*FvwmNoCLutter 172800 Destroy

###########################################################################
##### Identify
*FvwmIdentBack #000080
*FvwmIdentFore Yellow
*FvwmIdentFont -BASIC_FONT-medium-r-*-*-FONT_SIZE-*-*-*-*-*-*-*

###########################################################################
##### FvwmWinList
*FvwmWinListBack #c3c3c3
*FvwmWinListFore Black
*FvwmWinListFont -BASIC_FONT-bold-r-*-*-10-*-*-*-*-*-*-*
*FvwmWinListAction Click1 Iconify -1,Focus
*FvwmWinListAction Click2 Iconify
*FvwmWinListAction Click3 Module "FvwmIdent" FvwmIdent
*FvwmWinListUseSkipList
*FvwmWinListGeometry +0-1
        
###########################################################################
##### FvwmTaskBar
Style "FvwmTaskBar"	BorderWidth 3, HandleWidth 3, Sticky,
Style "FvwmTaskBar"	WinCircSkip, NoTitle
*FvwmTaskBarGeometry +1-0
*FvwmTaskBarFore MENUFORE_COLOR
*FvwmTaskBarBack MENUBACK_COLOR

changecom(%%%)
ifdef(`TASK_BAR_ICON_FORE_AND_BACK', `
*FvwmTaskBar: IconFore White
*FvwmTaskBar: IconBack Black
#*FvwmTaskBar: IconFore Black
#*FvwmTaskBar: IconBack White
')
changecom(#)

changecom(%%%)
ifdef(`TASK_BAR_FOCUS_FORE_AND_BACK', `
ifelse(HILIGHTBACK_COLOR, MENUBACK_COLOR, `
*FvwmTaskBar: FocusFore MENUSHINE_FORE_COLOR
*FvwmTaskBar: FocusBack MENUSHINE_BACK_COLOR
',`
*FvwmTaskBar: FocusFore HILIGHTFORE_COLOR
*FvwmTaskBar: FocusBack HILIGHTBACK_COLOR
')
*FvwmTaskBar: NoBrightFocus
')
changecom(#)

*FvwmTaskBarTipsFore black
*FvwmTaskBarTipsBack bisque

#*FvwmTaskBarFont -*-GENERAL_FONT_FAMILY-medium-r-*-*-FONT_SIZE-*-*-*-*-*-*-*
# Make it bold so that white on black shows up better
*FvwmTaskBarFont -*-GENERAL_FONT_FAMILY-bold-r-*-*-FONT_SIZE-*-*-*-*-*-*-*
*FvwmTaskBarSelFont -*-GENERAL_FONT_FAMILY-bold-r-*-*-FONT_SIZE-*-*-*-*-*-*-*

# Advised in 2.4 to not use comma style in Click actions
#*FvwmTaskBarAction Click1 Focus,Iconify -1,Focus,Raise
*FvwmTaskBarAction Click1 Function TaskBarActionClick1
#fvwm2.2 -- this used to work
#*FvwmTaskBarAction Click2 Focus,Iconify 1,Prev [!FvwmTaskBar Maximized !Iconic] FullMaximize,FullMaximize,Iconify -1,Focus
#fvwm2.4 -- now need this
#*FvwmTaskBarAction Click2 Focus,Iconify 1,Prev [!FvwmTaskBar Maximized !Iconic] FullMaximize,Iconify -1,FullMaximize,Focus,Raise
#fvwm2.5 -- now need this
*FvwmTaskBarAction Click2 Function TaskBarActionClick2
#*FvwmTaskBarAction Click3 Focus,Iconify 1
*FvwmTaskBarAction Click3 Function TaskBarActionClick3
*FvwmTaskBarUseSkipList
*FvwmTaskBarShowTransients
*FvwmTaskBarDeskOnly
# autostick seems to make task bar freeze in RH6.0
#*FvwmTaskBarAutoStick
ifdef(`ENABLE_TASKBAR_START_MENU', `
*FvwmTaskBarStartName Main
*FvwmTaskBarStartMenu StartMenu
', `
*FvwmTaskBarStartName NoStart
*FvwmTaskBarStartMenu NoStartMenu
')
*FvwmTaskBarStartIcon START_MENU_PIXMAP
*FvwmTaskBarBellVolume 10
*FvwmTaskBarMailBox MAIL_SPOOL_DIR
*FvwmTaskBarClockFormat %a %B %d %H:%M
*FvwmTaskBarShowTips
#*FvwmTaskBarAutoHide


AddToFunc TaskBarActionClick1
+ "I" Focus
+ "I" Iconify -1
+ "I" Focus
+ "I" Raise

AddToFunc TaskBarActionClick2
+ "I" Focus
+ "I" Iconify 1
+ "I" Prev [!FvwmTaskBar Maximized !Iconic] Function BasicFullMaximize
+ "I" Iconify -1
+ "I" Function BasicFullMaximize
+ "I" Focus

AddToFunc TaskBarActionClick3
+ "I" Focus
+ "I" Iconify 1


AddToMenu NoStartMenu "Temporarily disabled!" Title
+ "Due to minor bug" Title
+ "which can cause" Title
+ "FVWM2 to crash. :-(" Title
+ "We hope to solve this." Title
+ "Meanwhile, you can still use" Title
+ "this menu from the" Title
+ "root window (i.e. background)." Title


###########################################################################
##### FvwmAudio
*FvwmAudioDir SOUND_DIR
*FvwmAudioPlayCmd SOUND_COMMAND
*FvwmAudioDelay 0
# User must add a new column to each line below, specifying
# a sound file from SOUND_DIR (define-d in .fvwm2rc-defines)
*FvwmAudio startup 
*FvwmAudio shutdown 
*FvwmAudio unknown 
*FvwmAudio add_window 
*FvwmAudio raise_window 
*FvwmAudio lower_window 
*FvwmAudio focus_change_window 
*FvwmAudio destroy_window 
*FvwmAudio iconify 
*FvwmAudio deiconify 
*FvwmAudio toggle_paging 
*FvwmAudio new_page 
*FvwmAudio new_desk 
*FvwmAudio configure_window 
*FvwmAudio window_name 
*FvwmAudio icon_name 
*FvwmAudio res_class
*FvwmAudio res_name
*FvwmAudio end_windowlist

###########################################################################
######## FvwmScroll
*FvwmScrollFore gray76
*FvwmScrollBack gray51

###########################################################################
######## FvwmIconBox
*FvwmIconBoxIconBack    #cfcfcf
*FvwmIconBoxIconHiFore  black
*FvwmIconBoxIconHiBack  LightSkyBlue
*FvwmIconBoxBack        LightSlateGray
*FvwmIconBoxGeometry    6x1+0-0
*FvwmIconBoxMaxIconSize 64x50
*FvwmIconBoxFont        -adobe-helvetica-bold-r-normal--10-100-75-75-p-57-iso8859-1
*FvwmIconBoxSortIcons
*FvwmIconBoxPadding     4
*FvwmIconBoxLines       6
*FvwmIconBoxPlacement   Left Top
#*FvwmIconBoxPixmap      
*FvwmIconBoxHideSC 	Horizontal
*FvwmIconBoxSortIcons
# mouse bindings
*FvwmIconBoxMouse       1       Click           RaiseLower
*FvwmIconBoxMouse       1       DoubleClick     Iconify
*FvwmIconBoxMouse       2       Click           Iconify -1, Focus
*FvwmIconBoxMouse       3       Click           Module "FvwmIdent" FvwmIdent
*FvwmIconBoxSBWidth	2
# Key bindings
*FvwmIconBoxKey         r       RaiseLower
*FvwmIconBoxKey         space   Iconify
*FvwmIconBoxKey         d       Close
# FvwmIconBox built-in functions
*FvwmIconBoxKey         n       
*FvwmIconBoxKey         p       Prev
*FvwmIconBoxKey         h       Left
*FvwmIconBoxKey         j       Down
*FvwmIconBoxKey         k       Up
*FvwmIconBoxKey         l       Right
# Icon file spcifications
#*FvwmIconBox            "Fvwm*"         -

############################################################################
######### FvwmBanner
Style "FvwmBanner"   	StickyOnTop, WinCircSkip, BorderWidth 0

############################################################################
#
# FvwmScript - The very nice scripting module
#
*FvwmScriptPath  ANOTHERLEVEL/scripts

TraceForErrors(`Including forms...')
readFile(`fvwm2rc.forms')
